Name
        dapple2 - an Apple ][ emulator

Synopsis
        dapple2

Description
        Dapple ][ is a program which emulates an Apple ][ computer with
        48K or  64K RAM (or an Apple //e with  up to 3136K), two  5.25"
        floppy drives and a 3.5" high-density (1.40 MB)  floppy  drive.
        The  disk  drives  are simulated, through files on  the  user's
        hard  disk, with  the  exception  of  the 3.5" drive, which  is
        simulated on an actual 3.5" drive installed as drive A: on  the
        user's system.  A joystick  is also  emulated, using either the
        numeric keypad on a standard keyboard of a joystick or game pad
        connected to the PC game  port.  This manual reflects Dapple ][
        version 0.26.

        Dapple ][ currently has  no command-line  options.  If you have
        sufficient RAM, up to 3136K of  emulated  memory  will  be made
        available to programs which support the RAM Works protocol.  On
        the author's computer (with 32 MB of RAM and running under DOS)
        the full 3 MB is available.

        Dapple ][ is a functional, but not  perfect emulator, but there
        are  programs  that run  better on Dapple ][ than on some other
        freeware emulators.  Additionally, Dapple ][ is bilingual; some
        of the  messages (more in the future) emitted  by  the emulator
        have  been  translated (back-translated?)  into  German, and  a
        German keyboard layout is available.  (German users please note
        that the keyboard  in emulation mode is in the  QWERTY order by
        default, rather  than QWERTZ; many games  expect Z to be placed
        below  A, and  so  the  convention  has  been  followed.  This,
        however, is configurable.)

        Dapple ]['s  joystick emulation  may not  be perfect, if a real
        joystick is used.  The center value is based on the joypad used
        by the developer  that had one  to work with; your  own mileage
        may vary.

        Dapple ][ does not come with ROM images; however, methods exist
        for dumping the ROM from a real Apple ][ and using the freeware
        program "adt" to transfer  it to a PC.  (For an example, please
        see the "readme.1st" file in the distribution.) You should name
        the ROM images according to which Apple ][ series computer they
        represent:

                apple2.rom      Apple ][+
                apple2m.rom     Apple ][, Monitor ROM
                apple2o.rom     Apple ][, Autostart ROM ("INTBASIC")
                apple2eo.rom    Apple //e, original version ("][")
                apple2e.rom     Apple //e, enhanced version ("//e")
                apple2co.rom    Apple //c, original version (16K)
                apple2c.rom     Apple //c, newer version (32K)

        The systems  supported  by  both Dapple ][ and ApplePC  use the
        same  ROM  filenames.  You  can  place  Dapple ][ in  the  same
        directory  as ApplePC.  However, it is  not  recommended to use
        downloaded ROM files (which are usually in the  ApplePC format)
        for legal  reasons.  The proper  file size  for an Apple ][/][+
        ROM  is 12288 bytes; for the //e or  original //c, 16128 bytes;
        or for the  new //c, 32768 bytes.  (The newer //c uses  all but
        256 bytes of this space, which are  not accessible; there is no
        other common  format  for //c ROMs than  that used  by ApplePC,
        excepting possibly the format used by MESS.)

        In addition, Dapple ][ has begun to support a mouse in //e mode
        if the C4 page is dumped from Apple Oasis.  Work is progressing
        on rewriting the mouse code so as not to require code from that
        emulator.

        In some respects, Dapple ][ may be superior to a real Apple ][,
        although no emulator can ever hope to be  as good as a real ][.
        For example:

         * Dapple ][ emulates a US or German (more layouts coming soon)
           keyboard with full uppercase and lowercase characters on all
           models including the Apple ][ and ][+.  Not all programs can
           recognize this; by default, the Apple's BIOS does not handle
           this.  (Reading the  keyboard  directly will work, however.)
           If you have the Appler ROM, strip off the first four  bytes;
           the resulting ROM is compatible with  Dapple as an Apple ][+
           and supports lowercase in the BIOS.

         * Dapple ][ can read and write 1.4 MB floppy disks. The author
           knows of no PC emulators that  can read 3.5" disks, although
           he  has used  an Apple IIgs emulator  on the Macintosh which
           offered  this  functionality.  Very  few  Apple ][ computers
           (the  Mark  ][  prototype  being  an  exception) had 1.40 MB
           drives, but those  that  do  can  be  used to  transfer disk
           images easily to PCs by transferring files within Dapple, or
           using a file transfer  utility combined  with getdisk, which
           is available from SourceForge from the same place as Dapple.
           It is impossible, however, to read 800K Apple disks on a PC,
           since the coding  of the Apple disks (GCR) cannot be read by
           the PC's (MFM) hardware.  This is the same  reason that 140K
           (5.25") diskettes cannot be read on a PC.

        However, in many respects there are  other  superior emulators,
        more or less for the following reasons:

         * Dapple ][ seems not to like some programs.  (This is less of
           an issue than with earlier versions of Dapple.)

         * Dapple ][ doesn't do Z80.  Earlier versions of Dapple did in
           fact attempt this, but it never worked right, and the Dapple
           Z80 has finally been euthanized.

         * There are a couple aspects of  the  video  display  not  yet
           emulated in Dapple, although they are emulated in ApplePC.

        Dapple ][ features  a  simple debugger, which can be  activated
        using  the F9 key.  More  powerful  features  are  included  in
        Apple's own debugger,  which  is  activated  when  a  BRK ($00)
        opcode  is  encountered; however, Apple's monitor does not have
        support for the 65C02 opcodes (except on the //c).  Dapple ]['s
        disassembler has been  written with support  for all  the 65C02
        and 65SC02 opcodes.  The NMOS 6502 can  also  be  emulated, for
        those programs that require  its  opcodes, although  not all of
        the undocumented opcodes are supported yet.

        If you  prefer a monochrome  display, Shift-F3  toggles between
        color  and  three  types  of  monochrome  mode.  The monochrome
        settings do  not affect  lo-res  mode  and  have  retro-looking
        white, green or  amber color.  There is a  grayscale palette as
        well as three  different color  palettes - an approximation  of
        that used by  the  Apple IIgs; the RGB  palette as reported  by
        Robert Munafo, and  an  approximation  of  the palette  used by
        ApplePC.

        As in a few other PC-based emulators, you may press Ctrl-F12 to
        reset the emulated CPU.

Known bugs
        The  effect  of  enabling  double  low-resolution  graphics  in
        40-column mode is not emulated.

        There is limited support  for the mouse, but code from Apple ][
        Oasis is required.

        To  report  a  bug, e-mail  the  maintainer, Steve Nickolas, at
        <steve@dosius.zzn.com>.

Author
        The original Apple emulation code was written by Steve Nickolas
        <steve@dosius.zzn.com>.  Holger Picker  has also contributed to
        the emulator source; some vestiges  of  code originally written
        by Andrew Gregory  remain  as well.  Part of  the 6502 core was
        based on code supplied by Scott Hemphill.

Credits
        Some of the information  used  in  the  Dapple ][ emulator  was
        supplied  by  the   following   people.   We  appreciate  their
        occasionally unwitting contributions. :)

          Scott Alfter
          David Empson
          Andrew Gregory
          Lazarus I. Long
          Robert Munafo
          Jon Relay
          Paul R. Santa-Maria

        This program uses the WDOSX DOS extender by Michael Tippach.

        Thanks  Marat Fayzullin and  Marcel de Kogel for  the CPU cores
        which were formerly used in Dapple.

        (The author is sorry  if he has forgotten anyone; after all, he
        is only human.)
